Option Explicit
Dim filePath As Variant
Dim strPath     As String
Dim shtNam As String
Dim RowSize As Long
Dim CorSize As Long

Sub BDF_Load()
    filePath = Application.GetOpenFilename(filefilter:="BDFt@C(*.bdf),*.bdf")
    If filePath = False Then Exit Sub
    Dim fi As Variant
    fi = Array(Array(1, xlTextFormat))
    Dim maxRow As Long
    Workbooks.OpenText Filename:=filePath, FieldInfo:=fi, Space:=True
    Dim ws As Worksheet
    Set ws = Workbooks.Item(Workbooks.Count).Sheets(1)
    ws.Move After:=ThisWorkbook.Sheets(ThisWorkbook.Sheets.Count)
    Dim shtNam As String
    shtNam = ActiveSheet.Name                    ' VV[g擾
    Worksheets("16dot").Range("C1").Value = shtNam
    maxRow = ThisWorkbook.Sheets(shtNam).Cells(1, 1).End(xlDown).row
    MsgBox shtNam & " [h܂ " & maxRow
    Worksheets("16dot").Select
End Sub

Sub findKey()
    Dim ws As Worksheet
    Set ws = Worksheets(Worksheets.Count)
    Dim kw As String
    kw = "ENCODING"
    RowSize = 16
    CorSize = 16
    Dim code As Long
    code = Worksheets("16dot").Range("B24").Value
    Dim i As Integer
    Dim r As Range
    With ws.Range("A:A")
        Worksheets("16dot").Range("C1").Value = ws.Name
        Set r = .Find(what:="FONTBOUNDINGBOX", LookAt:=xlWhole)
        If r Is Nothing Then
            Exit Sub
        Else
            CorSize = r.Offset(0, 1).Value
            Worksheets("16dot").Range("C2") = CorSize
            RowSize = r.Offset(0, 2).Value
            Worksheets("16dot").Range("E2") = RowSize
        End If
    
        Set r = .Find(what:=kw, LookAt:=xlWhole)
        Do
            If r Is Nothing Then
                MsgBox ("Y")
                Exit Do
            Else
                If r.Next.Value = code Then
   '                 Debug.Print r.Address & "  " & r.Next.Value
                    For i = 1 To 16
                        If i <= RowSize Then
                            Worksheets("16dot").Range("B4").Offset(i) = r.Offset(4 + i).Value
                        Else
                            Worksheets("16dot").Range("B4").Offset(i) = 0
                        End If
                    Next i
                    Worksheets("16dot").Select
                    Exit Do
                Else
                    Set r = .FindNext(r)
                End If
            End If
        Loop While Not r Is Nothing
    End With
End Sub

Sub saveHex()
    Dim fso         As Object
    Dim tso         As Object
'    Dim strPath     As String
    Dim hData()     As String
    Dim i As Integer, j As Integer, rofs As Integer, dsz As Integer, cnt As Integer
    
    Set fso = CreateObject("Scripting.FileSystemObject")
    strPath = Worksheets(Worksheets.Count).Name & ".csv"
    Set tso = fso.OpenTextFile(strPath, 8, True)
    RowSize = Worksheets("16dot").Range("E2")
    CorSize = Worksheets("16dot").Range("C2")
    rofs = 10 + 16 - CorSize
    dsz = CorSize * 2 + 2
    ReDim hData(dsz) As String
    Debug.Print CorSize & " " & dsz
    cnt = 0
    For j = 0 To 1
        For i = 0 To CorSize - 1
            hData(cnt) = "0x" & Cells(21 + j, rofs + i).Value
            cnt = cnt + 1
        Next i
    Next j
    hData(cnt) = "//"
    hData(cnt + 1) = Cells(23, 2)
    hData(cnt + 2) = Cells(23, 4)
    
    Debug.Print "data-saved"
    With tso
        .WriteLine Text:=Join(hData, ",")
        .Close  't@C̃N[Y
    End With
    Set fso = Nothing
    Set tso = Nothing
End Sub

Sub saveHex_m()
    Call saveHex
    MsgBox CurDir() & "\" & strPath & " Ƀf[^ǉ܂"
End Sub

Sub ShowFolderPicker()
    Dim fd As FileDialog
    Set fd = Application.FileDialog(msoFileDialogFolderPicker)
    With fd
        If .Show = -1 Then
            MsgBox "IꂽtH_: " & .SelectedItems(1)
            ChDir Path:=.SelectedItems(1)
        Else
            MsgBox "tH_I܂łB"
        End If
    End With
End Sub

Sub SerialEC()

    Dim cmd As String
    Dim row As Integer
    Dim rcv As String
    Dim S_Time As Date

    ec.COMn = Range("AB2")          '@ݒ
    ec.Setting = "115200,n,8,2"
    'ec.Delimiter = ec.DELIMs.LfCr
    ec.AsciiLineTimeOut = 1000
    cmd = Range("AB4")              'Af[^̑M
    ec.AsciiLine = cmd
    row = 8                         'Bf[^̎M
    Range("AB6:AB40").Value = ""
    S_Time = Now
    Do
        If Now > S_Time + TimeSerial(0, 0, 1) Then
            Exit Do                 'TimeOut 2sec
        End If
        DoEvents
        Debug.Print "EC: " & ec.InBuffer
        If ec.InBuffer > 0 Then
            DoEvents
            rcv = ec.AsciiLine
            Cells(row, 28) = rcv
            row = row + 1
            S_Time = Now
   '     Else
   '        Exit Do
        End If
    Loop

    ec.InBufferClear                'Mobt@NA
    ec.COMn = -1                    'C|[g I
    Range("AB4").Value = ""         'DMf[^̏

End Sub

Sub setSerialData()
    Dim sData()     As String
    Dim i As Integer, j As Integer, rofs As Integer, dsz As Integer, cnt As Integer
    RowSize = Worksheets("16dot").Range("E2")
    CorSize = Worksheets("16dot").Range("C2")
    rofs = 10 + 16 - CorSize
    dsz = CorSize * 2 + 1
    ReDim sData(dsz) As String
    If Range("AC2") = "W" Or Range("AC2") = "S" Then
        sData(0) = Range("AC2") & Range("AD2")
        cnt = 1
    Else
        cnt = 0
    End If
    For j = 0 To 1
        For i = 0 To CorSize - 1
            sData(cnt) = Cells(21 + j, rofs + i).Value
            Debug.Print cnt; " "; sData(cnt)
            cnt = cnt + 1
        Next i
    Next j
    Cells(4, 28) = Join(sData, ",")
End Sub

Sub addAddress()
    Dim adr As Variant
    Dim hdt As Variant
    hdt = WorksheetFunction.Hex2Dec(Range("ad2"))
    adr = Val(hdt) + Range("C2") * 2
    Range("AD2") = WorksheetFunction.Dec2Hex(adr, 5)
End Sub

Sub sendPlus()
    Call SerialEC
    Call addAddress
End Sub

Function cnv_j_s(jcd) As Variant
    Dim msb, lsb, jsm As Integer
    msb = Int(jcd / 256)
    lsb = jcd Mod 256
    If msb = &H21 Then
        If lsb >= &H21 And lsb < &H60 Then
            cnv_j_s = &H8140 + (lsb - &H21)
        Else
            cnv_j_s = &H8140 + (lsb - &H20)
        End If
    
    ElseIf msb = &H23 Then
        If lsb >= &H30 And lsb <= &H39 Then
            cnv_j_s = &H824F + (lsb - &H30)
        ElseIf lsb >= &H41 And lsb <= &H5A Then
            cnv_j_s = &H8260 + (lsb - &H41)
        ElseIf lsb >= &H61 And lsb <= &H7A Then
            cnv_j_s = &H8281 + (lsb - &H61)
        Else
            cnv_j_s = 0
        End If
    ElseIf msb = &H24 Then
        If lsb >= &H21 And lsb <= &H73 Then
            cnv_j_s = &H829F + (lsb - &H21)
        Else
            cnv_j_s = 0
        End If
    ElseIf msb = &H25 Then
        If lsb >= &H21 And lsb <= &H76 Then
            cnv_j_s = &H8340 + (lsb - &H21)
        Else
            cnv_j_s = 0
        End If
    ElseIf msb >= &H30 And msb <= &H4F Then
        jsm = Fix((msb - &H30 + 1) / 2)
 '       Debug.Print jsm
        If msb Mod 2 = 0 Then
            If lsb >= &H21 And lsb <= &H7E Then
                cnv_j_s = &H889F + (lsb - &H21) + jsm * 256
            Else
                cnv_j_s = 0
            End If
        Else
            If lsb >= &H21 And lsb < &H60 Then
                cnv_j_s = &H8840 + (lsb - &H21) + jsm * 256
            Else
                cnv_j_s = &H8840 + (lsb - &H20) + jsm * 256
            End If
        End If
    Else
        cnv_j_s = 0
    End If
        
End Function

Sub AutoSet()
    Dim cd As Variant, kj As Variant
    Dim cds As Integer, cde As Integer
    Dim sMs As Integer, sLs As Integer
    Dim eMs As Integer, eLs As Integer
    Dim cMs As Integer, cLs As Integer
    Dim n As Integer, s As Integer, e As Integer
            
    cds = WorksheetFunction.Hex2Dec(Range("B26"))
    sMs = Int(cds / 256)
    sLs = cds Mod 256
    cde = WorksheetFunction.Hex2Dec(Range("B27"))
    eMs = Int(cde / 256)
    eLs = cde Mod 256
    n = 0
    
    For cMs = sMs To eMs
        If cMs = sMs Then
            If cMs < eMs Then
                s = sLs
                e = &H7E
            Else
                s = sLs
                e = eLs
            End If
        Else
            s = &H21
            If cMs = eMs Then
                e = eLs
            Else
                e = &H7E
            End If
        End If
        
        For cLs = s To e
            cd = cMs * 256 + cLs
            Debug.Print Hex(cd)
            If cd = &H2147 Then
                Cells(23, 4) = "'f"
                DoEvents
            Else
                kj = cnv_j_s(cd)
                If kj = 0 Then
                    Debug.Print "Code Error!!"
                    Exit Sub
                Else
                    Cells(23, 4) = Chr(kj)
                End If
            End If
            DoEvents
            Call findKey
            DoEvents
            Call saveHex
            DoEvents
            Call setSerialData
            DoEvents
            Call SerialEC
            DoEvents
            Call addAddress
            DoEvents
            n = n + 1
        Next
    Next
End Sub

Sub exc_auto()
    Call AutoSet
    DoEvents
End Sub
